'' VECTORJET v0.0
'' (C)2020 IRQsome Software
'' Display list helper

VAR
  long head ' current write position
  long left ' how much space left
  long link ' last list link word
PUB start(ptr,size)
  head := ptr
  left := size
  link := $8080

PUB putlink
  word[link] := head
  link := head
  putword(0)

PUB putlong(x)
  if (left -= 4) < 0
    abort 1
  'if head & 3
    'abort 2
  long[head] := x
  head += 4

PUB putword(x)
  if (left -= 2) < 0
    abort 3
  'if head & 1
    'abort 4
  word[head] := x
  head += 2

PUB putbyte(x)
  if (--left) < 0
    abort 5
  byte[head++] := x

PRI round_f16(x)
  return ((x >> 15)+1)>>1

PUB slopeCalc(x1,x2,y1,y2)

  return ((x1-x2))/(y1.word[1]-y2.word[1]+1)+1

PUB point(x,y,colors) '' HORRIBLY INEFFICIENT FOR TEST USE ONLY

putlink
putword(y.word[1]) ' start line
putword(y.word[1]+1) ' end line
putword(-1) ' init sync to -1
putbyte(1) ' type
putbyte(0) ' unused
putword(0) ' unused
repeat 2
    putlong(0)
putlong(x)
putlong(x+$10000)
putword(1)
putword(colors)
putlong(0)
putlong(0) 

PUB triangle(x1,y1,x2,y2,x3,y3,colors) | tmp,tmp2,tmp3

if y1 > y2
  tmp := y1
  y1 := y2
  y2 := tmp
  
  tmp := x1
  x1 := x2
  x2 := tmp
  
if y1 > y3
  tmp := y1
  y1 := y3
  y3 := tmp
  
  tmp := x1
  x1 := x3
  x3 := tmp
  
if y2 > y3
  tmp := y2
  y2 := y3
  y3 := tmp
  
  tmp := x2
  x2 := x3
  x3 := tmp

if y2~>16 == y1~>16 AND y2~>16 == y3~>16
    return ' reject degenerate triangle

putlink
putword(y1.word[1]) ' start line
putword(y3.word[1]+1) ' end line
putword(-1) ' init sync to -1
putbyte(1) ' type
putbyte(0) ' unused
putword(0) ' unused

if y2~>16 == y3~>16 ' bottom flat?
  
  'pst.str(string("bottom flat",13)) 
  repeat 2
    putlong(0)
  tmp := slopeCalc(x3,x1,y3,y1)
  tmp2:= slopeCalc(x2,x1,y2,y1)
  if x2 > x3    
    putlong(x1+tmp)
    putlong(x1+tmp2)
  else    
    putlong(x1+tmp2)
    putlong(x1+tmp)

  putword((y3.word[1])-(y1.word[1])+1)
  putword(colors)
  if x2 > x3
    putlong(tmp)
    putlong(tmp2)
  else                                          
    putlong(tmp2)
    putlong(tmp) 

elseif y1~>16 == y2~>16 ' top flat?
  'pst.str(string("top flat",13))
  
  repeat 2
    putlong(0)

  tmp := slopeCalc(x3,x2,y3,y2)
  tmp2:= slopeCalc(x3,x1,y3,y1)
  if x1 > x2
    putlong(x2+tmp)
    putlong(x1+tmp2)
  else
    putlong(x1+tmp2)
    putlong(x2+tmp)
    
  putword((y3.word[1])-(y1.word[1])+1)
  putword(colors)
  

  if x1 > x2
    putlong(tmp)
    putlong(tmp2)
  else
    putlong(tmp2)
    putlong(tmp)

else
  'pst.str(string("other",13))
  
  repeat 2
    putlong(0)

  tmp := slopeCalc(x3,x1,y3,y1) ' long slope
  tmp2 := slopeCalc(x2,x1,y2,y1)' short slope
  if tmp2 > tmp
    putlong(x1+tmp)
    putlong(x1+tmp2)
    putword((y2.word[1])-(y1.word[1]))
    'putword($CCCC)
    putword(colors)
    
    putlong(tmp)
    putlong(tmp2)   
  else
    putlong(x1+tmp2)
    putlong(x1+tmp)
    putword((y2.word[1])-(y1.word[1]))
    'putword($CCCC)
    putword(colors)
    
    putlong(tmp2)
    putlong(tmp) 
  
  putword((y3.word[1])-(y2.word[1])+1)
  'putword($4C4C)
  putword(colors)

  tmp3 := slopeCalc(x3,x2,y3,y2) 
  if tmp2 > tmp
    putlong(tmp)
    putlong(tmp3)
  else
    putlong(tmp3)
    putlong(tmp)    


  